using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;

namespace ElevatedPrivilage
{
    [Guid("28ec73e1-e88f-4f51-8ac6-986da95ebc34")]
    public class ElevatedPrivilageWP : Microsoft.SharePoint.WebPartPages.WebPart
    {
       
        public ElevatedPrivilageWP()
        {
            this.ExportMode = WebPartExportMode.All;
        }     

        protected override void Render(HtmlTextWriter writer)
        {
            SPSite curSite = SPContext.Current.Site;
            writer.Write("<b>Non-elevated Site ID</b>:" + curSite.ID);

            using (SPSite newSite = new SPSite(curSite.Url))
            {
             using (SPSite elevSite = Utils.GetElevatedSite(newSite))
                {
                    using (SPWeb elevWeb = elevSite.OpenWeb())
                    {
                        //Do the dangerous work here
                        writer.Write("<br/><br/><b>Elevated Site ID:</b>" + elevSite.ID);
                    }
                }
            }

        }
       
    }
}
